/**
 * Copyright: Copyright (c) 2008 Jacob Carlborg. All rights reserved.
 * Authors: Jacob Carlborg
 * Version: Initial created: Nov 18, 2008
 * License: $(LINK2 http://opensource.org/licenses/bsd-license.php, BSD Style)
 * 
 */
module dwt.internal.objc.cocoa.bindings;

import tango.stdc.config;

import dwt.internal.c.Carbon;
import dwt.internal.cocoa.NSRect;
import dwt.internal.objc.cocoa.Cocoa;
import dwt.internal.objc.runtime;

enum NSSearchPathDirectory
{
    NSApplicationDirectory = 1,
    NSDemoApplicationDirectory,
    NSDeveloperApplicationDirectory,
    NSAdminApplicationDirectory,
    NSLibraryDirectory,
    NSDeveloperDirectory,
    NSUserDirectory,
    NSDocumentationDirectory,
    NSDocumentDirectory,
    NSCoreServiceDirectory,
    NSDesktopDirectory = 12,
    NSCachesDirectory = 13,
    NSApplicationSupportDirectory = 14,
    NSDownloadsDirectory = 15,
    NSAllApplicationsDirectory = 100,
    NSAllLibrariesDirectory = 101
}

enum NSSearchPathDomainMask
{
    NSUserDomainMask = 1,
    NSLocalDomainMask = 2,
    NSNetworkDomainMask = 4,
    NSSystemDomainMask = 8,
    NSAllDomainsMask = 0x0ffff,
}

alias c_long NSInteger;
alias c_ulong NSUInteger;

extern (C):

//NSAccessibility.h
id NSAccessibilityActionDescription (id action);
void NSAccessibilityPostNotification (id element, id notification);
void NSAccessibilityRaiseBadArgumentException (id element, id attribute, id value);
id NSAccessibilityRoleDescription (id role, id subrole);
id NSAccessibilityRoleDescriptionForUIElement (id element);
id NSAccessibilityUnignoredAncestor (id element);
id NSAccessibilityUnignoredChildren (id originalChildren);
id NSAccessibilityUnignoredChildrenForOnlyChild (id originalChild);
id NSAccessibilityUnignoredDescendant (id element);

//NSGraphics.h
void NSBeep ();
NSInteger NSBitsPerPixelFromDepth (NSWindowDepth depth);



// NSGeometry.h
NSRect NSIntersectionRect (NSRect aRect, NSRect bRect);



// NSHFSFileTypes.h
id NSFileTypeForHFSTypeCode (OSType hfsFileTypeCode);



// NSObjCRuntime.h
/*const*/ char * NSGetSizeAndAlignment (/*const*/ char* typePtr, NSUInteger* sizep, NSUInteger* alignp);



// NSPathUtilities.h 
id NSSearchPathForDirectoriesInDomains (NSSearchPathDirectory directory,NSSearchPathDomainMask domainMask,BOOL expandTilde);
id NSTemporaryDirectory ();